
     CHKPASS                  L. Broadfield                   CHKPASS


     NAME
          chkpass -- a security aid for Netware administrators
                     version 1.3, 9 October 92.

     SYNOPSIS
          chkpass -wWord-list-file  [ -u ]  [-aBegin-after] 

     DESCRIPTION
          Chkpass is a simple tool for network administrators
          or security officers to check Netware objects for
          easy-to-guess passwords.

          The user supplies chkpass with a file containing 
          passwords to be tested.  Chkpass scans the bindery,
          retrieving objects.  If the object does not have
          the password property, it is skipped.  Otherwise, the 
          VerifyBinderyObjectPassword service is used to test
          each password in the file against the object.

          To run chkpass, the -w parameter must be supplied.
          The -w parameter is the name (a path may be included)
          of a file containing one password per line.  Case is
          not significant, since it appears that Netware upcases
          passwords internally.  Up to 32767 passwords (lines)
          may appear in the file.


          Options:
          
            -u     Only objects of type OT_USER will be checked if
                   this flag is present.

                   Note that some objects other than OT_USER _do_
                   have the password property (e.g. print servers)
                   but generally these are more directly under the
                   supervisor's control.

            -aBegin-after
                   Because the process of running chkpass can last
                   *days* (more on this later) the -a flag can be
                   used to resume an aborted run.  Chkpass will
                   skip objects as it reads the bindery until it
                   reaches the "begin-after" object.  It will skip
                   that object, and begin testing with the following
                   object.


          Example:

           F:\TOOLS> chkpass -wbad_pws.dat -aLPB -u >1.out


          Notes:

          AT NO TIME WILL THIS PROGRAM OUTPUT A PASSWORD.  There is
          no mechanism, feature, or even hidden option to cause
          chkpass to display a found password.  It's certainly 
          remotely possible to hack the executable to breakpoint
          at the success decision point, but anyone with that much 
          skill could far more easily write their own program.

          TURN INTRUDER DETECTION OFF WHILE RUNNING CHKPASS!  (Then,
          turn it back on.  It is a Good Thing.)  Each unsuccessful
          attempt by chkpass to verify a password counts toward the
          intruder detection threshold.  If chkpass finds a locked out
          object (whether or not it caused the lockout) it will
          continue to the next object.  Thus, if intruder detection
          is on, it will carefully test a few passwords against each
          object, hit the failure threshold, and continue to the next
          object, carefully locking out the entire system by the time
          it's done.
          
          There is no "undocumented Netware" in here.  Only five
          Netware calls are made, and those are straight out of the 
          standard manuals.
              
          Time.  It takes a lot.  This appears to be a Novell mechanism
          to prevent exactly this sort of attack from a hostile.  Each
          attempt takes roughly 3 seconds even on an unloaded server.
          If you're running a 952 password test file against a 60 user
          bindery, that's nearly 48 hours.  (That's why there's a way
          to resume an interrupted check with the -a flag.)  Try it out 
          with a short (two or three line) password file to become
          familiar with it.

          Optimum use of the program is to run it on a spare station
          (or in the background if you have a multi-tasking station)
          with the output redirected into a log file.  There is some
          stderr output that will appear even with normal output
          redirected into a file to reassure you that it's running
          and inform you of it's progress.  When it's done, you will
          have a file of results, with a few (or even no!) objects
          indicated as "Password verify returned true".  You can then
          ignore the results, change passwords, or send an email to the
          indicated users, as appropriate.

          Such a note might read:

            Dear XXX:

            An automated test tool has determined that you are using
            an "easy to guess" password.  Please change your password
            at your very earliest opportunity.  
 
            Remember that certain classes of passwords should 
            particularly be avoided: proper names, alphabetic
            sequences, and keyboard sequences are all vulnerable
            to guessing.

            A virtually ideal password can be formed by taking two
            unrelated nouns, separated by a punctuation mark, 
            such as ICEPICK*STOAT or HALIBUT!BOTTLE.

            Thanks!

            P.S.  If you don't change your password, we'll send
            Big Guido to change your mind.


          About password test files: Along with the executable and
          this man page, you should have received RTM.DAT, the file
          of passwords used so successfully by RTM's infamous
          Internet worm.  This is by no means an all-encompassing
          file; it is heavily canted toward academia, and contains
          far too few proper names and keyboard sequences.  My own
          testfile is 952 entries long, heavily salted with proper
          names, programming terms, and accounting terms.  You should
          develop your own additions, from experience, imagination,
          and perhaps documents or memos from your own site.  Don't
          forget to include a blank line to catch accounts with no
          password.

          Supervisor rights:  This version tests for the user to be
          supervisor or supervisor equivalent.  I honestly can't think
          of a way that this tool could be abused, but just in case,
          I put this test in.  I'd prefer to release it without this 
          test, so it can be run from a non-supervisor station, so
          users don't have to be as concerned about securing the station
          it's running on.  I'm going to put this version out with 
          this test, but unless I hear a good reason, I'll take it
          out of the next version.


     DISCLAIMERS
          Have fun, but don't blame me.  For anything.  Chkpass has been
          tested on Netware 2.2 and 3.11 and appears to work, without
          side-effects (except as noted above.)  As with any security
          tool, or indeed most tools, it can be used or misused.

          Any trademarks are whoever's they are.

     BUGS
          None known.


     FUTURE FEATURES
          
          Should have a -n flag, to suppress checks of test passwords
          shorter than the required minimum of the object.  This should
          be an option, though, since it *is* possible to have a shorter
          password in place than the required length value.

          Should have a -oDate flag, to suppress checks of accounts whose
          passwords appear to have been changed since Date.  Since this
          value can only be calculated from the "password expiration
          date" and the change period, this is also not guaranteed to
          catch all cases (although under "normal" circumstances it
          would.)

          Should have a -q flag, for ultra-quiet operation.  The 
          only output to a redirected file would be names of objects
          returning true, one per line.  This would ease creating an
          entirely automated process.
         

     BUG REPORTS AND COMMENTS TO

          Laird P. Broadfield     lairdb@crash.cts.com       or
                                  70110.236@compuserve.com   or (from CI$)
                                  70110,236


     COPYRIGHTS
          Copyright 1992 by L. Broadfield.  This is FREEWARE (freeware
          note: I can remember when there was a lot more freeware out
          there; the fun and challenge of creating it was the payment.
          Seems to me the decline is largely due to people losing sight
          of "small and useful" in favor of "bloated and mouse-driven."
          Personally, I *like* small and useful tools.)  Distribute it,
          use it, have fun.

          I ask only two things:

             1.  Please don't muck about with it.  It works, and
                 it's got my name on it.  Please distribute it as-is,
                 with this documentation intact.

             2.  Let me know if you use it.  Feedback is always 
                 appreciated but I like to know even if it's just 
                 "Hi.  My name's Bob and we use your chkpass tool 
                 here at FOOBAR Corp."
                
END            
